#!/bin/sh -e
#set -x
#CURRENT_TRY TRY_TO_SEND_MAIL
FILE_STATUS="/var/lib/dialserver/dial_status"
#TIME MAX BEFORE RESETING. SECONDS
#5h
TIME_MAX=18000 

TAIL_MAINLOG=""
TAIL_LICENSESERVERLOG=""
TAIL_WEBSERVICELOG=""

SO_INFO=$(cat /etc/issue)
SO_INFO="$SO_INFO\n"
SO_INFO="$SO_INFO `uname -a`"

#arg1 = number of try
sendMail() {
FECHA_EMAIL=`LANG=en_EN date '+%a, %d %b %Y %X %z'`
TEXTO_EMAIL="From: Dial_status
To: alertasdialapplet@gmail.com
Content-type: text/plain; charset=UTF-8
Subject: LANZO DIALSERVER CLIENTE (cliente)
Date: $FECHA_EMAIL
Se ha tenido que lanzar el dialserver porque estaba parado.

INFORMACION ADICIONAL

Intento: $1 

SO INFO: $SO_INFO

Últimas líneas de /var/log/dialserver/mainlog:
$TAIL_MAINLOG

Últimas líneas de /var/log/dialserver/licenseserverlog:
$TAIL_LICENSESERVERLOG

Últimas líneas de /var/log/dialserver/webservicelog:
$TAIL_WEBSERVICELOG"

echo "$TEXTO_EMAIL" | sendmail -t

echo "* Email sended (try $1)"
}

#arg1 = current. arg2 = next
updateFileStatus() {
    if [ $1 -lt $TIME_MAX ]; then
    	echo "$1 $2" > $FILE_STATUS
    else
    	echo "1 1" > $FILE_STATUS
    fi
}

dialServerStatus() {
LINEAS=`ps -ef | grep -v grep | grep "dialserver" | wc -l`

##not running
if [ $LINEAS -eq 0 ]
then 
return 0
#running
else
return 1
fi
}

#if file does not exists, create it with default
if [ ! -f $FILE_STATUS ]; then
    echo "1 1" > $FILE_STATUS
fi


dialServerStatus
#running
if [ $? -eq 1 ]; then
    updateFileStatus 1 1
    echo "Dialserver running, NO LANZO"

##not running
else
    echo "Dialserver not running, LANZO"
    /etc/init.d/dialserver start
    current=`cat $FILE_STATUS | cut -f1 -d' '`
    next=`cat $FILE_STATUS | cut -f2 -d' '`

    if [ $current -eq $next ]; then
		#sleep to wait until logs are written
		sleep 2
		TAIL_MAINLOG=$(tail -n 10 /var/log/dialserver/mainlog)
		TAIL_LICENSESERVERLOG=$(tail -n 10 /var/log/dialserver/licenseserverlog)
		TAIL_WEBSERVICELOG=$(tail -n 10 /var/log/dialserver/webservicelog)
        sendMail $current
        updateFileStatus $(($current+1)) $(($next*2))

    else
        updateFileStatus $(($current+1)) $(($next))
        echo "Try $current. [Next inform mail in $(($next-$current))]"

    fi

   
fi
